package com.usky.dao.Impl;

import com.usky.dao.BaseDao;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

/**
 * @author laowo
 * @version v1.0
 * @date 2020/2/20 16:37
 * @description TODO
 **/
@Repository
@Transactional
public class BaseDaoImpl implements BaseDao {
    @Autowired
    @Qualifier("sessionFactory")
    private SessionFactory sessionFactory;
    @Override
    public Session getSession() {
        // 事务必须是开启的(Required)，否则获取不到
        //return sessionFactory.openSession();
        return sessionFactory.getCurrentSession();
    }
}
