package com.usky.service.Impl;

import com.alibaba.fastjson.JSONObject;
import com.usky.service.SendWXService;
import com.usky.utils.HttpClientUtilWX;
import com.usky.utils.HttpClientUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.apache.log4j.Logger;
import org.hibernate.Query;
import org.hibernate.SQLQuery;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @Author zhangzilong
 * @Description //TODO
 * @Date $ $
 * @Param $
 * @return $
 */
@Service
@Transactional
public class SendWXServiceImpl extends BaseServieImpl implements SendWXService {
    private static final Logger LOGGER = Logger.getLogger(HtServiceImpl.class);

    @Override
    @Async
    public void YGsendWX(String devid, String loraWanId, String timeStamep, String evt) {
        long startTime = System.currentTimeMillis();
        LOGGER.info("++++++++++++++++++++++++++++++++告警数据上传微信++");
        List<NameValuePair> nameValuePairsList = new ArrayList<>();
        StringBuffer sb = new StringBuffer();
        String sql = "SELECT company FROM sp_owner where owner_code='" + devid + "'";
        SQLQuery query = getSession().createSQLQuery(sql);
        List list = query.list();
        Object o = list.get(0);
        for (Object b : list) {
            System.out.println("b = " + b.toString());
        }
        String s = o.toString();
        String sql1 = "SELECT phone from sp_owner_phone  where data2 like'%6%' and owner_code='" + s + "'";
        Query query1 = getSession().createSQLQuery(sql1);
        List list1 = query1.list();
//        for (Object b : list1) {
//            System.out.println("b111 = " + b.toString());
//        }
        if (list1 != null && list1.size() > 0) {
            for (Object sp : list1) {
                sb.append(sp);
                sb.append(",");
                // System.out.println("sp = " + sp);
            }
        }
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String time = df.format(new Date());
        BasicNameValuePair basicNameValuePair1 = new BasicNameValuePair("IMEI", devid);
        // BasicNameValuePair basicNameValuePair2 = new BasicNameValuePair("phone",sb.toString());
        BasicNameValuePair basicNameValuePair2 = new BasicNameValuePair("phone", sb.toString());
        BasicNameValuePair basicNameValuePair3 = new BasicNameValuePair("insert_id", loraWanId);
        BasicNameValuePair basicNameValuePair4 = new BasicNameValuePair("time", time);
        BasicNameValuePair basicNameValuePair = new BasicNameValuePair("evt", evt);
        nameValuePairsList.add(basicNameValuePair);
        nameValuePairsList.add(basicNameValuePair1);
        nameValuePairsList.add(basicNameValuePair2);
        nameValuePairsList.add(basicNameValuePair3);
        nameValuePairsList.add(basicNameValuePair4);

        String url = "http://iot.usky.cn/jdxf/wxapp2.php/Home/Waterwarn/bj";
        HttpClientUtilWX.doFromPost(url, null, nameValuePairsList);
        System.out.println("发送微信");
        long endTime = System.currentTimeMillis();

        long usedTime = (endTime - startTime) / 1000;
        LOGGER.info("++++++++++++++++++++++++++++++++告警数据上传微信完成++++耗时：" + usedTime + "秒+++++++++");

    }


    //发送微信
    @Override
    @Async
    public void CoversendWX(String imei, String id, String time, String evtname, String deviceStatus) {
        long startTime = System.currentTimeMillis();
        LOGGER.info("++++++++++++++++++++++++++++++++告警数据开始上传微信*");

//        String hql = "from sp_iw2017 t where t.Id=" + id;
//        Query q = getSession().createQuery(hql);
//        List list2 = q.list();
        // String time1 = tRoleList.getTime();
        //System.out.println("time1 = " + time1);

        List<NameValuePair> nameValuePairsList = new ArrayList<>();
        StringBuffer sb = new StringBuffer();
        String sql = "SELECT company FROM sp_owner where owner_code='" + imei + "'";
        SQLQuery query = getSession().createSQLQuery(sql);
        List list = query.list();
        Object o = list.get(0);
        for (Object b : list) {
            System.out.println("b = " + b.toString());
        }
        String s = o.toString();
        String sql1 = "SELECT phone from sp_owner_phone  where data2 like'%6%' and owner_code='" + s + "'";
        Query query1 = getSession().createSQLQuery(sql1);
        List list1 = query1.list();
        for (Object b : list1) {
            System.out.println("b111 = " + b.toString());
        }
        if (list1 != null && list1.size() > 0) {
            for (Object sp : list1) {
                sb.append(sp);
                sb.append(",");
            }
        }
        BasicNameValuePair basicNameValuePair1 = new BasicNameValuePair("device_code", imei);
        // BasicNameValuePair basicNameValuePair2 = new BasicNameValuePair("phone",sb.toString());
        BasicNameValuePair basicNameValuePair2 = new BasicNameValuePair("phone", sb.toString());
        BasicNameValuePair basicNameValuePair3 = new BasicNameValuePair("insert_id", id);
        BasicNameValuePair basicNameValuePair4 = new BasicNameValuePair("time", time);
        BasicNameValuePair basicNameValuePair = new BasicNameValuePair("evt", evtname);
        nameValuePairsList.add(basicNameValuePair);
        nameValuePairsList.add(basicNameValuePair1);
        nameValuePairsList.add(basicNameValuePair2);
        nameValuePairsList.add(basicNameValuePair3);
        nameValuePairsList.add(basicNameValuePair4);
if (!"0".equals(deviceStatus)){
    String url = "https://iot.usky.cn/jdxf/wxapp2.php/Home/ManholeCoverwarn/message_manhole_cover";
    HttpClientUtilWX.doFromPost(url, null, nameValuePairsList);
}

        LOGGER.info("********************************告警数据上传微信完成*");
        JSONObject cObj = new JSONObject();
        /*SubType: 设备类型，井盖（不含液位），140
DeviceId: 设备编号，sp_owner表中的owner_code
InsertId: 告警报告列表的ID
Confirmed: 告警确认标识，0
CompanyCode: 单位编号，sp_owner表中的company字段
evt_name: 告警名称，例如井盖打开
evt: 告警编号，等下发你
alarm_time: 告警时间，yyyy-MM-dd HH:mm:ss*/
       /* 53 打开
        54 关闭*/
if (StringUtils.isNotEmpty(deviceStatus)){

    cObj.put("SubType", "140");
    cObj.put("DeviceId", imei);
    cObj.put("InsertId", id);
    cObj.put("Confirmed", "0");
    cObj.put("CompanyCode", o);

    if ("54".equals(deviceStatus)){
        cObj.put("evt_name", "井盖关闭");
        cObj.put("evt", "54");
    }else if ("53".equals(deviceStatus)){
        cObj.put("evt_name", "井盖开启");
        cObj.put("evt", "53");
    }else if ("0".equals(deviceStatus)){
        cObj.remove("InsertId");
        cObj.put("sig",evtname);
        cObj.put("bat",id);
    }

    cObj.put("alarm_time", time);

    final String curl = "http://47.98.201.73:55125/report";
    HttpClientUtils.doPostJson(curl,cObj.toJSONString());
}




     //发送到c程序
        JSONObject js = new JSONObject();
        js.put("SubType", "128");
        js.put("DeviceId", imei);
        js.put("InsertId", id);
        js.put("Confirmed", "false");
        LOGGER.info("********************************告警数据开始上传C程序完成*");


        HttpClientUtils.doPostJson("http://47.98.201.187:55335/report", js.toJSONString());

        long endTime = System.currentTimeMillis();

        long usedTime = (endTime - startTime) / 1000;
        LOGGER.info("++++++++++++++++++++++++++++++++告警数据上传C程序完成++++耗时：" + usedTime + "秒+++++++++");

    }


}
